 
 #include "ADC.h"
 #include "LCD.h"
 #include "intrins.h"
 
 void ADC_Init(void)
	{
		P1M1 = 1;	P1M0 = 0;		     //Ϊ
        ADCCFG |= 0x0F;		             //룬ʱΪ512T
	  //  ADC_CONTR |= 0x80;	             //ADC power on	
		
	}	
	
	/**************************************************/
	/****************ADCתѡͨ*****************/
	/**************************************************/
	
 unsigned int Get_ADC12bitResult(unsigned char channel)	//channel = 0~7
  {
		unsigned int ADC_Dat=0;
		ADC_CONTR &= 0Xd0;
	    ADC_CONTR |= 0xC0 + ( channel & 0X0F ); 	//ʼתADCѡͨ
	  
	    while((ADC_CONTR & 0x20) == 0);	      //ȴADCת
	  _nop_();
	  _nop_();
	    ADC_CONTR &= ~0x20;		              //ADC־
		ADC_Dat = ADC_RES ;                   // Ĭϸֽڸ8λ
	    ADC_Dat = ADC_Dat<<4;
		ADC_Dat = ADC_Dat | ADC_RESL >> 4;	                              
	    return ADC_Dat;
	 //return (((unsigned int)ADC_RES << 2) | (ADC_RESL & 3));
	}
	 
	/******************************ADCֵ˲**********************************/
	
 unsigned int ADC_Avg(unsigned char channel)       
  {
	unsigned long	j;
	unsigned int	k;		//ƽֵ˲ʱʹ

	Get_ADC12bitResult(channel);		//i=0~7,ѯʽһADC, лͨһת. ݵĲдѹӰ.
	j = Get_ADC12bitResult(channel);		//i=0~15,ѯʽһADC, лͨһת. ݵĲдѹӰ.
	j = 0;
	for(k=0; k< 50; k++)
	{	
	   j += Get_ADC12bitResult(channel);	// ۼӺ   0~15,ѯʽһADC, ֵǽ
	}
	j = j / 50;		// ƽ
	return j;
	}
	/*****************ѹʾ**************************/
	
  void display_voltage()
  {
	    unsigned long voltage_voltage;
        unsigned long int voltage;
	    unsigned int a,b,c,d;
	    voltage_voltage = ADC_Avg(7);
	    voltage = (voltage_voltage * 4110 * 10 / 4096)-50;
	  
	    a = voltage / 10000;                 //ʮλ
		b = voltage % 10000/1000;            //λ
		c = voltage % 1000/100;              //ٷλ
	    d = voltage % 100/10;
	    display [0][3]=0x30+a;
	    display [0][4]=0x30+b;
	    display [0][6]=0x30+c;
	    display [0][7]=0x30+d;
  }
  
  /*****************ʾ**********************************/
  void display_current()
  {
	    unsigned long voltage_curren;
        unsigned  int current;
	    unsigned int a,b,c,d;
	    voltage_curren = ADC_Avg(6);
		current= voltage_curren * 4110 * 4 / 4095;
	  
//	  if(current>18300 && current<27000)
//	  {
//		  current = (current/1200)*1000;
//	  }
//	  
//	  if(current>27000 && current<38300)
//	  {
//		  current = (current/1330)*1000;
//	  }  
//	  
//	   if(current>38300&& current<72000)
//	  {
//		  current = (current/1470)*1000;
//	  }  
//	  
	     a = current / 10000;
		 b = current % 10000/1000;
		 c = current % 1000/100;
	     d = current % 100/10;
	    display [0][14]=0x30+a;
	    display [0][15]=0x30+b;
	    display [0][17]=0x30+c;
	    display [0][18]=0x30+d;
    
  }
  
  void display_power()
  {
	   unsigned long voltage_curren;
	   unsigned long voltage_voltage;
        unsigned long power;
	  
	    unsigned int a,b,c,d; 
	  voltage_curren = ADC_Avg(6); 
	  voltage_voltage = ADC_Avg(7);
	  
	  power = voltage_curren * voltage_voltage * 4 / 10000;
	  
	     a = power / 1000;
		 b = power % 1000/100;
		 c = power % 100/10;
	     d = power % 10/1;
	    display [2][6]=0x30+a;
	    display [2][7]=0x30+b;
	    display [2][8]=0x30+c;
	    display [2][10]=0x30+d;
    
  }