
#include "stc8f.h"
#include "key.h"
#include "delay.h"
#include "lcd.h"
#include "dac.h"

#define uint unsigned int
#define uchar unsigned char
unsigned int DA_V = 0;
unsigned int DA_I = 0;
/*********************ɨ*********/

void Key_Scan()
{
    unsigned int key_num = 0, key_no = 0xff;      //¼ֵ
    static unsigned char M = 0x01, k = 0x01;
    P2 = key_no;

    if(P2 != 0xFF)             //а
    {
        DelayMS(5);
        if(P2 != 0xFF)      //
        {
            switch(P2)       //жϼֵӦļ
            {
            case 0xfe:
                key_num = 1;
                break;
            case 0xfd:
                key_num = 2;
                break;
            case 0xfb:
                key_num = 3;
                break;
            case 0xf7:
                key_num = 4;
                break;
            case 0xef:
                key_num = 5;
                break;
            case 0xdf:
                key_num = 6;
                break;
            case 0xbf:
                key_num = 7;
                break;
            case 0x7f:
                key_num = 8;
                break;
            }
        }
        while(P2 != 0xff);
    }				  //ⰴͷ
	
    /*************************************************/
    /******************ִа*******************/
    /*************************************************/

    if(key_num == 2)                     //˵£к
    {
        k ^= 0x01;                      //־λȡǣ׼´μ

        if(k == 1)
        {
            display [1][8] = '_';
            display [1][17] = '.';
        }
        else if(k == 0)
        {
            display [1][17] = '_';
            display [1][8]  = '.';
        }

        M = 0;
    }

    /**************ѹ5**********************/
    if(M == 0)
    {
        if(key_num == 3)    //k3½-5
        {
            if(k == 1 && DA_V > 599)
            {
                DA_V = DA_V - 500;
            }
            else if(k == 0 && DA_I >1274)
            {
                DA_I =DA_I-1250;
            }
        }

        /**************ѹ1**********************/

        if(key_num == 4)    //k4½-1
        {
            if(k == 1 && DA_V > 199)
            {
                DA_V = DA_V - 100;
            }
            else if(k == 0 && DA_I > 499)
            {
                DA_I = DA_I - 250;
            }
        }

        /**************ѹ0.1**********************/

        if(key_num == 5)    //k5½-0.1
        {
            if(k == 1  && DA_V > 19)
            {
                DA_V = DA_V - 10;
            }
            else if(k == 0  && DA_I > 49)
            {
                DA_I = DA_I - 25;
            }
        }

        /**************ѹ0.1**********************/

        if(key_num == 6)    //k6½+0.1
        {
            if(k == 1 && DA_V < 3100)
            {
                DA_V = DA_V + 10;
            }
            else if(k == 0 && DA_I < 2725)
            {
                DA_I = DA_I + 25;
            }
        }

        /**************ѹ1**********************/

        if(key_num == 7)    //k7½+1
        {
            if(k == 1 && DA_V < 3010)
            {
                DA_V = DA_V + 100;
            }
            else if(k == 0 && DA_I < 2499)
            {
                DA_I = DA_I + 250;
            }
        }

        /**************ѹ5**********************/

        if(key_num == 8)    //k8½+5
        {
            if(k == 1 && DA_V < 2610)
            {
                DA_V = DA_V + 500;
            }
            else if(k == 0 && DA_I<1500 )
            {
                DA_I = DA_I+1250;
            }
        }

        /***********************************ȷ****************************/

        if(key_num == 1)          //K1DAֵ
        {
            display [1][8]   = '.';
            display [1][17]  = '.';
			
 /**************************************/
 /***************ѹ***************/ 
 /**************************************/	
			
                if(DA_V <= 3110 & DA_V >= 100)   //жDAֵ
                {
                    Write_DAC_Value(0x9000 | DA_V+7);
                }

                else if(DA_V > 3110) // ֵ3V3V
                {
                    DA_V = 3110;
                    Write_DAC_Value(0x99c4);
                }

                else if(DA_V < 100)  //ֵС0.1V0.1V
                {
                    DA_V = 100;
                    Write_DAC_Value(0x90fa);
                }

      /**************************************/
      /******************************/ 
      /**************************************/
         
                if(DA_I <= 2500 && DA_I >= 25)
                {
                    Write_DAC_Value(0x1000 | DA_I);
                }

                else if(DA_I > 2500) // ֵ2.5V2.5V
                {
                    DA_I = 2500;
                    Write_DAC_Value(0x19c4);
                }

                else if(DA_I < 25)  //ֵС0.025V0.025V
                {
                    DA_I = 25;
                    Write_DAC_Value(0x10fa);
                }
          //  }
            M = 1;
        }
    }
}


void display_DAV()
{
    int a, b, c,d;
    a = DA_V * 10 / 10000;
    b = DA_V * 10 % 10000 / 1000;
    c = DA_V * 10 % 1000 / 100;
	d = DA_V * 10 % 100 / 10;
    display [1][6]  = 0x30 + a;
    display [1][7]  = 0x30 + b;
    display [1][9]  = 0x30 + c;
    display [1][10] = 0x30 + d;
}

void display_DAI()
{
    int a, b,c;
    a = DA_I * 4 / 10000;
    b = DA_I * 4 % 10000 / 1000;
	c = DA_I * 4 % 1000/100;
    display [1][15] = 0x30 + a;
    display [1][16] = 0x30 + b;
    display [1][18] = 0x30 + c;
}