
#include "LCD.h"
#include "delay.h"
#include <intrins.h>
#include "adc.h"

/*Ļʾ*/		

unsigned char idata display [4][20]=
{
	{"Vo:  .  V  Io:  .  A"},
	{"Set V:  .  V I:  . A"},
	{"Power:   . W        "},
	{"WenDu:   . T        "}
};
unsigned char code Welcome [4][20]=
{
	{"   Welcome to use   "},
	{"     Swich Power    "},
	{"       30V/10A      "},
	{"        300W        "}
};

/************************************************
:LCD׼
:LCDǰ׼
ڲ:
ز:
************************************************/
void LCD1602_Busy(void)
{
    LCD1602_DATA=0xff;
	DelayMS(1);
	RS=0;
	RW=1;
	E=1;
	while(LCD1602_DATA & 0x80);
	E=0;
}
/************************************************
:дLCD
:дݵLCD
ڲ:
	num:Ҫд
	i:	0,д	1,д		
ز:
************************************************/
void LCD1602_WRITE(unsigned char num ,unsigned char i)
{
    LCD1602_Busy();
	RS=i;
	RW=0;
	E=0;
	LCD1602_DATA=num;
	DelayMS(1);
	E=1;
	E=0;
	
}

/************************************************
:LCDʼ
:LCDʼ
ڲ:		
ز:
************************************************/
void LCD1602_Init(void)
{
	unsigned char i,j;
	LCD1602_WRITE(0X38,0);
	LCD1602_WRITE(0X08,0);
	LCD1602_WRITE(0X01,0);
	LCD1602_WRITE(0X06,0);
	LCD1602_WRITE(0X0C,0);
	LCD1602_WRITE(0X80,0);

    for(i = 0; i < 4; i++)
    {
        for(j = 0; j < 20; j++)
        {
            LCD1602_DISPLAY(i, j, Welcome[i][j]);
        }
    }
	DelayMS(2000);
}

/************************************************
:LCDʾ
:LCDʾָ
ڲ:
	y:	(0~1)
	x:	(0-15)
	v:	ҪдASCIIַ		
ز:
************************************************/
void LCD1602_DISPLAY(unsigned char y ,unsigned char x,unsigned char v)
{
	switch(y)
	{
		case 0:
	            x+=0x80;break;
	    case 1:
	            x+=0xc0;break;
	    case 2:
	            x+=0x94;break;
	    case 3:
	            x+=0xd4;break;
	    }
//	if(y==1)
//		{
// 			x+=0x40;
//	   }
//		
//	if(y == 2)
//		{
//			x+=0xc0;
//		}
//		
//	if(y == 3)
//		{
//			x+=0x94;
//		}
//	x+=0x80;
	LCD1602_WRITE(x,0);
	LCD1602_WRITE(v,1);
	
}

void LCD1602_ALL(void)
{
	unsigned char i,j;
    for(i = 0; i < 4; i++)
    {
        for(j = 0; j < 20; j++)
        {
            LCD1602_DISPLAY(i, j, display[i][j]);
        }
    }
}

/************************************************
:LCD
:ʾLCD
ڲ:
	sw:	0,رչ	1,򿪹
	y:	(0~1)
	x:	(0-15)		
ز:
************************************************/
//void LCD1602_CURSOR(unsigned char sw,unsigned char y,unsigned char x)
//{
//	unsigned char guangbiao_cmd=0X0C;
//	if(sw&&y<2&&x<16)
//	{
//		LCD1602_WRITE(0x0F,0);    //  ùΪ˸
//		if(y) guangbiao_cmd=0XC0+x;
//		else guangbiao_cmd=0X80+x;
//	}
//	LCD1602_WRITE(guangbiao_cmd,0);    //  ùΪ˸ 
//}
